-- **************************************************************************
--   TitanPalsUtils.lua
--
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanPals", true );

-- **************************************************************************
-- NAME : TitanPals_CoreUtils( b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12 )
-- DESC : This makes everything happen
-- **************************************************************************
function TitanPals_CoreUtils( b1, b2, b3, b4, b5, b6, b7, b8, b9, b10, b11, b12 )
     local palsDB = ( "%s:%s" ):format( TitanPalsProfile.Faction, TitanPalsProfile.Realm )
     local b = { [1] = b1, [2] = b2, [3] = b3, [4] = b4, [5] = b5, [6] = b6, [7] = b7, [8] = b8, [9] = b9, [10] = b10, [11] = b11, [12] = b12, };
     if ( TitanPalsInit and TitanPalsDebug.State ) then
          local tdLine
          for i = 1, 10 do
               if ( i == 1 ) then
                    if ( b[i] ) then tdLine = ( "[|cffff9900%s|r]" ):format( b[i] ); end
               else
                    if ( b[i] ) then tdLine = tdLine .. ( "[|cffff9900%s|r]" ):format( b[i] ); end
               end
          end
          TitanPalsDebug.dLine = ( "Recieved : %s" ):format( tdLine );
	  TitanPals_DebugUtils( "bug", "CoreUtils", TitanPalsDebug.dLine );
          collectgarbage( "collect" );
     end

     if ( b[1] == "UpDate" ) then
          -- [b1    ][b2     ][b3   ][b4    ]
          -- [Action][Faction][Realm][Player]
          TitanPals_SetUser();
          local NumPals = GetNumFriends();
          local Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno, fIndex;
          for fIndex = 1, NumPals do
               --[Name][Level][Class][Area][Connected][Status][Note]
               Palsn, Palsl, Palsc, Palsa, Palsco, Palss, Palsno = GetFriendInfo( fIndex );
               if ( not TitanPalsLists[palsDB][Palsn] ) then TitanPalsLists[palsDB][Palsn] = {}; end
               if ( not Palsco ) then 
                    if ( not TitanPalsLists[palsDB][Palsn].Level ) then TitanPalsLists[palsDB][Palsn].Level = tonumber( Palsl ); end
                    if ( not TitanPalsLists[palsDB][Palsn].Class ) then TitanPalsLists[palsDB][Palsn].Class = Palsc; end
                    if ( not TitanPalsLists[palsDB][Palsn].Note ) then TitanPalsLists[palsDB][Palsn].Note = "na"; end
               else
                    TitanPalsLists[palsDB][Palsn].Level = tonumber( Palsl );
                    TitanPalsLists[palsDB][Palsn].Class = Palsc;
                    if ( not Palsno ) then
                         TitanPalsLists[palsDB][Palsn].Note = "na";
                    else
                         TitanPalsLists[palsDB][Palsn].Note = Palsno;
                    end
               end
          end
          collectgarbage( "collect" );
     elseif ( b[1] == "ToolTipN" ) then
          --[b1    ][b2   ][b3  ][b4  ][b5   ][b6   ][b7  ][b8    ][b9  ][b10    ]
          --[Action][Right][Left][Name][Level][Class][Area][Status][Note][Offline]
          --[[ !s - Status ][ !l - Level ][ !p - Player ][ !z - Zone ][ !n - Note ][ !c - Class ][ !uc - Colored Players Name ]]--
          if ( b[5] == 0 ) then b[5] = "-"; end
          if ( string.match( b[8], "(.*):(.*)" ) ) then
               local BNA, BND = string.match( b[8], "(.*):(.*)" );
               if ( BNA == "nil" ) then BNA = nil; end
               if ( BND == "nil" ) then BND = nil; end
               if ( BNA or BND ) then
                    if ( BNA ) then b[2] = string.gsub( b[2], "!s", TitanPals_ColorUtils( "GetCText", "sgray", TitanPals.Settings.SFormat ) ); end
                    if ( BND ) then b[2] = string.gsub( b[2], "!s", TitanPals_ColorUtils( "GetCText", "sgray", TitanPals.Settings.DFormat ) ); end
               else
                    b[2] = string.gsub( b[2], "!s", " " );
               end
          else
               if ( b[8] == "<AFK>" or b[8] == ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ) or b[8] == ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_DND"] ) or b[8] == "<ALT>" or b[8] == ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ) ) then
                    if ( b[8] == ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ) ) then
                         b[8] = TitanPals.Settings.SFormat;
                    elseif ( b[8] == ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_DND"] ) or b[8] == ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ) ) then
                         b[8] = TitanPals.Settings.DFormat;
                    end
                    b[2] = string.gsub( b[2], "!s", TitanPals_ColorUtils( "GetCText", "sgray", b[8] ) );
               else
                    b[2] = string.gsub( b[2], "!s", " " );
               end
          end
          if ( b[5] == BNET_CLIENT_SC2 or b[5] == BNET_CLIENT_D3 ) then
               b[2] = string.gsub( b[2], "!l", TitanPals_ColorUtils( "GetCText", "orange", b[5] ) );
          else
               b[2] = string.gsub( b[2], "!l", TitanPals_ColorUtils( "GetCText", "orange", b[5] ) );
          end
          b[2] = string.gsub( b[2], "!p", TitanPals_ColorUtils( "GetCText", "orange", b[4] ) );
          b[2] = string.gsub( b[2], "!c", TitanPals_ColorUtils( "GetCClass", b[6], b[6] ) );
          if ( not b[9] ) then
               b[2] = string.gsub( b[2], "!n", "" );
          else
               b[2] = string.gsub( b[2], "!n", TitanPals_ColorUtils( "GetCText", "gray", b[9] ) );
          end
          if ( b[7] ) then
               b[2] = string.gsub( b[2], "!z", TitanPals_ColorUtils( "GetCText", "sgray", b[7] ) );
          else
               b[2] = string.gsub( b[2], "!z", TitanPals_ColorUtils( "GetCText", "gray", b[10] ) );
          end
          b[2] = string.gsub( b[2], "!uc", TitanPals_ColorUtils( "GetCClass", b[6], b[4] ) )
          -- TitanPals_DebugUtils( "bug", "ToolTipN", b[2] )
          b[11], b[12] = string.match( b[2], "(.*)~(.*)" )
          return b[11], b[12];
     elseif ( b[1] == "ToolTipID" ) then
          --[b1    ][b2    ][b3        ][b4       ][b5       ][b6        ][b7       ][b8   ][b9    ]
          --[Action][Format][First Name][Last Name][Character][Realm Name][Full Name][Class][Client]
          b[2] = string.gsub( b[2], "!sn", TitanPals_ColorUtils( "GetCClass", b[8], b[3] ) );
          b[2] = string.gsub( b[2], "!ln", TitanPals_ColorUtils( "GetCClass", b[8], b[4] ) );
          b[2] = string.gsub( b[2], "!cn", TitanPals_ColorUtils( "GetCClass", b[8], b[5] ) );
          b[2] = string.gsub( b[2], "!rn", TitanPals_ColorUtils( "GetCClass", b[8], b[6] ) );
          b[2] = string.gsub( b[2], "!fn", TitanPals_ColorUtils( "GetCClass", b[8], b[7] ) );
          b[2] = string.gsub( b[2], "!gn", TitanPals_ColorUtils( "GetCText", "gray", b[9] ) );
          return b[2];
     elseif ( b[1] == "DisplayB" ) then
          --[b1    ]
          --[Action]
          UpdateAddOnMemoryUsage();
          TitanPalsDebug.dLine = ( "%s kb" ):format( floor( GetAddOnMemoryUsage( "TitanPals" ) ) );
          TitanPals_DebugUtils( "info", "load", LB["TITAN_PALS_CONFIG_BANNER_FORMAT"]:format( LB["TITAN_PALS_ADDON_LABEL"], LB["TITAN_PALS_CORE_VERSION"], TitanPalsDebug.dLine ) );
          collectgarbage( "collect" );
     elseif ( b[1] == "MakeSafe" ) then
          local text
          if ( b[2] == true ) then text = "true"; end
          if ( b[2] == false ) then text = "false"; end
          if ( b[2] == nil ) then text = "nil"; end
          return text;
     elseif ( b[1] == "playFriends" ) then
          --[b1    ]
          --[Action]
          local pTable = TitanPalsLists[palsDB];
          for n, v in pairs( pTable ) do
               local name = TitanPals_ColorUtils( "GetCClass", v.Class, n );
               local level = TitanPals_ColorUtils( "GetCText", "hlight", ( "%s" ):format( v.Level ) );
               TitanPals_DebugUtils( "info", b[1], ( "(%s) %s" ):format( level, name ) );
          end
          collectgarbage( "collect" );
     elseif ( b[1] == "playAlts" ) then
          --[b1    ]
          --[Action]
	  local pTable = TitanPalsAlts[palsDB];
          for n, v in pairs( pTable ) do
               local name = TitanPals_ColorUtils( "GetCClass", v, n );
	       local class = TitanPals_ColorUtils( "GetCClass", v, ( "%s" ):format( v ) );
               TitanPals_DebugUtils( "info", b[1], ( "(%s) %s" ):format( class, name ) );
          end
          collectgarbage( "collect" );
     elseif ( b[1] == "Author" ) then
           local Authors = {
               ["Lindarena@Laughing Skull"] = true,
               ["Stâbsâlot@Laughing Skull"] = true,
               ["Hilyna@Laughing Skull"] = true,
               ["Nagdand@Laughing Skull"] = true,
               ["Holycurves@Laughing Skull"] = true,
               ["Holytree@Laughing Skull"] = true,
               ["Acatra@Laughing Skull"] = true,
               ["Nâsh@Laughing Skull"] = true,
               ["Loansone@Laughing Skull"] = true,
               ["Koton@Laughing Skull"] = true,
          }
          for i = 1, getn( TitanPals.AddAuth ) do
               if ( not Authors[TitanPals.AddAuth[i]] ) then
                    Authors[TitanPals.AddAuth[i]] = true;
               else
                    tremove( TitanPals.AddAuth, i );
                    TitanPals_DebugUtils( "bug", "AddAuth", "Can Not Add Author Already Exists!" )
               end
          end
          return Authors[b[2]];
     elseif ( b[1] == "AddAuth" or b[1] == "addauth" ) then
          b[2] = ( "%s@%s" ):format( TitanPalsProfile.Player, TitanPalsProfile.Realm );
          TitanPals_DebugUtils( "info", "CoreUtils", LB["TITAN_PALS_CONFIG_ADDAUTHOR"]:format( b[2] ) );
          tinsert( TitanPals.AddAuth, b[2] );
          collectgarbage( "collect" );
     elseif ( b[1] == "RemAuth" or b[1] == "remauth" ) then
          b[2] = ( "%s@%s" ):format( TitanPalsProfile.Player, TitanPalsProfile.Realm );
          for i = 1, getn( TitanPals.AddAuth ) do
               if ( b[2] == TitanPals.AddAuth[i] ) then
                    TitanPals_DebugUtils( "info", "CoreUtils", LB["TITAN_PALS_CONFIG_REMAUTHOR"]:format( b[2] ) );
                    tremove( TitanPals.AddAuth, i );
               end
          end
          collectgarbage( "collect" );
     elseif ( b[1] == "getLocals" ) then
          local localClass = {};
          local sex, gender, gType
          for i = 1, 2 do
               if ( i == 1 ) then sex = true; gType = "TRUE";
               elseif ( i == 2 ) then sex = false; gType = "FALSE"; end
               FillLocalizedClassList( localClass, sex );
               for token, localName in pairs( localClass ) do
                    local color = RAID_CLASS_COLORS[token];
                    local colorCode = ( "%02x%02x%02x" ):format( ( color.r * 255 ), ( color.g * 255 ), ( color.b * 255 ) );
                    local richText = ( "|cff%s%%s|r" ):format( colorCode );
                    TitanPals_DebugUtils( "bug", "LCT", richText );
                    gender = ( "%s_%s" ):format( token, gType );
                    TitanPalsLocals.ColorClass[gender] = richText;
                    TitanPalsLocals.LocalClass[gender] = localName;
                    TitanPalsLocals.ToEnglish[localName] = gender;
               end
          end
          TitanPals_GameClients();
          collectgarbage( "collect" );
     elseif ( b[1] == "checkEdit" ) then
          local tReturn = {};
          local nEdit = false;
          local fList = TitanPalsLists[palsDB];
          for n, v in pairs( fList ) do
               if ( v.Level == 0 or v.Class == LB["TITAN_PALS_CONFIG_UNKNOWN"] ) then
                    tinsert( tReturn, { name = n, value = n, } );
                    nEdit = true;
               end
          end
          if ( b[2] == "_true" ) then return nEdit, tReturn;
          else return nEdit; end
          collectgarbage( "collect" );
     end
end

-- **************************************************************************
-- NAME : TitanPals_DebugUtils( d1, d2, d3, d4, d5 )
-- DESC : For debug messaging and print messages to chat frame
-- **************************************************************************
function TitanPals_DebugUtils( d1, d2, d3, d4, d5 )
     local d = { [1] = d1, [2] = d2, [3] = d3, [4] = d4, [5] = d5, };
     --[d1    ][d2      ][d3   ]
     --[Action][Function][error]
     if ( d[1] == "info" ) then
          DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_PALS_CORE_ITAG"]:format( d[3] ) );
     elseif ( d[1] == "error" ) then
          DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_PALS_CORE_ETAG"]:format( d[3] ) );
     elseif ( d[1] == "bug" and TitanPalsDebug.State ) then
          local fError = ( "[%s] %s" ):format( TitanPals_ColorUtils( "GetCText", "gold", d[2] ), d[3] );
          DEFAULT_CHAT_FRAME:AddMessage( LB["TITAN_PALS_CORE_DTAG"]:format( fError ) );
          if ( TitanPalsDebug.LogEvent ) then tinsert( TitanPalsDebug.Temp, d[3] ); end
     end
end

-- **************************************************************************
-- NAME : TitanPals_ResetUtils( r1, r2, r3, r4, r5 )
-- DESC : Diffrent ways to fix / reset Data Array
-- **************************************************************************
function TitanPals_ResetUtils( r1, r2, r3, r4, r5 )
     local r = { [1] = r1, [2] = r2, [3] = r3, [4] = r4, [5] = r5, };
     --[r1    ][r2    ][r3  ][r4   ]
     --[reload][action][pram][value]
     if ( r[2] == "reset" ) then
          if ( r[3] == "settings" ) then
               TitanPalsInit = nil;
               TitanPals = nil;
          elseif ( r[3] == "locals" and r[4] == "LocalClass" or r[4] == "ToEnglish" or r[4] == "ColorClass" ) then
               TitanPalsLocals[r[4]] = {};
               TitanPals_CoreUtils( "getLocals" );
          elseif ( r[3] == "array" and r[4] == "dTypes" or r[4] == "sTypes" or r[4] == "presets" or r[4] == "realidformats" ) then
               TitanPalsInit = false;
               TitanPalsStaticArrays[r[4]] = nil;
               r[1] = true;
          elseif ( r[3] == "all" ) then
               if ( r[4] ) then
                    if ( r[4] == "locals" ) then 
                         wipe( TitanPalsLocals );
                         TitanPalsLocals.LocalClass = {};
                         TitanPalsLocals.ColorClass = {};
                         TitanPalsLocals.ToEnglish = {};
                         TitanPals_CoreUtils( "getLocals" );
                         r[1] = false;
                    elseif ( r[4] == "array" ) then
                         TitanPalsInit = false;
                         TitanPalsStaticArrays = {};
                         r[1] = true;
                    elseif ( b[4] == "lists" ) then
                         TitanPalsLists = {};
                    elseif ( b[4] == "alts" ) then
                         TitanPalsAlts = {};
                    end
               elseif ( not r[4] ) then
                    TitanPalsInit = nil;
                    TitanPals = nil;
                    TitanPalsLists = nil;
                    TitanPalsAlts = nil;
                    TitanPalsStaticArrays = nil;
                    TitanPalsLocals = nil;
               end
          else 
               TitanPals_DebugUtils( "error", "CommandHandler", LB["TITAN_PALS_HELP_CMD_UNKNOWN"] );
          end
     elseif ( r[2] == "checkDB" or r[2] == "checkdb" ) then
          TitanPals_Init( "checkDB" );
          TitanPanelButton_UpdateButton( LB["TITAN_PALS_CORE_ID"] );
          TitanPanelButton_UpdateTooltip( self );
     end
     if ( r[1] ) then ReloadUI(); end
end

-- **************************************************************************
-- NAME : TitanPals_ColorUtils( c1, c2, c3, c4, c5 )
-- DESC : for coloring the tooltip and messages
-- **************************************************************************
function TitanPals_ColorUtils( c1, c2, c3, c4, c5 )
     local c = { [1] = c1, [2] = c2, [3] = c3, [4] = c4, [5] = c5, };
     if ( c[1] == "GetCText" ) then
          --[c1    ][c2   ][c3  ]
          --[Action][Color][Text]
          local color = strupper( c[2] )
          local colorCode
          local colorCache = {
               GREEN = "|cff00ff00%s|r",
               BLUE = "|cff00ffff%s|r",
               GRAY = "|cff808080%s|r",
               SGRAY = "|cff98afc7%s|r",
               HLIGHT = "|cffffffff%s|r",
               NORMAL = "|cffffd200%s|r",
               ORANGE = "|cffff9900%s|r",
               RED = "|cffff0000%s|r",
               GOLD = "|cffff9900%s|r",
          }
          colorCode = colorCache[color]:format( c[3] );
          return colorCode;
     elseif ( c[1] == "GetCClass" ) then
          --[c1    ][c2   ][c3    ]
          --[Action][Class][Player]
          local classEng, localClass, colorCode;
          colorCode = "|cff808080%s|r";
          if ( c[2] == LB["TITAN_PALS_CONFIG_UNKNOWN"] ) then 
               colorCode = "|cff808080%s|r";
          else
               classEng = TitanPalsLocals.ToEnglish[c[2]];
               localClass = TitanPalsLocals.LocalClass[classEng];
               colorCode = TitanPalsLocals.ColorClass[classEng];
          end
          return colorCode:format( c[3] );
     end
end

-- **************************************************************************
-- NAME : TitanPals_GameClient()
-- DESC : This may or may not get used
-- **************************************************************************

function TitanPals_GameClients()
     local gender;
     local richText = "|cff00ffff%s|r"
     TitanPals_DebugUtils( "bug", "LCT", richText );
     local cTable = { BNET_CLIENT_WOW, BNET_CLIENT_SC2, BNET_CLIENT_D3, }
     table.foreach( cTable, function( Key, Data )
               gender = ( "%s_%s" ):format( Data, Data );
               TitanPalsLocals.ColorClient[gender] = richText;
               TitanPalsLocals.LocalClient[gender] = Data;
               TitanPalsLocals.ClientEnglish[Data] = gender;
          end
     )
end

-- **************************************************************************
-- NAME : TitanPanelPals_StaticPopup( notesAdd )
-- DESC : Dialog for custom Notes
-- **************************************************************************

function TitanPanelPals_StaticPopup( notesAdd )
     StaticPopupDialogs["TITAN_PALS_CUSTOM_NOTE"] = {
          text = LB["TITAN_PALS_STATIC_ADDNOTE"],
          button1 = TEXT( ACCEPT ),
          button2 = TEXT( CANCEL ),
          hasEditBox = 1,
          maxLetters = 250,
          OnAccept = function( self )
               local pNote = self.editBox:GetText();
               if ( notesAdd.Type == "Normal" ) then
                    SetFriendNotes( notesAdd.Player, pNote )
               elseif ( notesAdd.Type == "BNet" ) then
                    BNSetFriendNote( notesAdd.pID, pNote );
               end
          end,
          OnShow = function( self )
               self.editBox:SetFocus();
          end,
          OnHide = function( self )
               self.editBox:SetText( "" );
          end,
          EditBoxOnEnterPressed = function( self )
               local parent = self:GetParent();
               local pNote = parent.editBox:GetText();
               self:GetParent():Hide();
          end,
          EditBoxOnEscapePressed = function( self )
               self:GetParent():Hide();
          end,
          timeout = 0,
          exclusive = 1,
          whileDead = 1,
          hideOnEscape = 1
     };
     StaticPopup_Show( "TITAN_PALS_CUSTOM_NOTE", notesAdd.PlayerColored );
end